<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 30/08/13
 * Time: 14:28
 * To change this template use File | Settings | File Templates.
 */

namespace Curriculo\Logic\Mail;

use Curriculo\Logic\CUR;

class RecuperarSenha {

    const SUBJECT_RECUPERAR_SENHA = 'Recuperação de Senha';

    /**
     * Carrega template do body do email
     * @return $template
     * @author leonardocarvalho
     */
    private function getTemplate($novasenha){

        $nrorg = CUR::getNrorg();
        $nmoperador = CUR::getNmoperador();
        $content = "Sua nova senha é: <b>".$novasenha."</b>";
        $logo_bottom = 'http://vagas.pebbian.com/images/pebbian_logotipo.png';
        $logo_organização = 'http://rh.pebbian.com/images/logo/'.$nrorg.'-logo.png';

        $template = <<<HTML
                    <!--<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> -->
                    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
                    <html>
                    <head>
                        <title>Recuperação de Senha</title>
                    </head>
                    <body style="text-align: center; padding-top: 2%; padding-left: 22%; background-color: rgb(118, 192, 179); margin: 0px; height: auto;">
                        <div style="width:672px; height:375px; box-shadow: 10px 10px 5px #78887d;">
                            <table cellpadding="0" cellspacing="0" style="width: 674px; height: 375px; margin: 0 auto;">
                                <tr style="background-color: #FFF">
                                    <td height="20">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF;">
                                    <td style="text-align: center;">
                                        <img src="$logo_organização" />
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF">
                                    <td height="35">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF; text-align: left; font: normal 14px Arial, Tahoma, sans-serif; color: #333;">
                                    <td>
                                        <table cellpadding="0" cellspacing="0">
                                            <tr>
                                                <td width="24"></td>
                                                <td height="193">
                                                    <h1 style="font-size: 30px; margin: 0 0 15px 0; color: #76c0b3;">Olá $nmoperador</h1>
                                                    <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                        $content
                                                    </p>
                                                    <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                        Acesse nosso sistema informando sua nova senha, após o acesso altere a mesma.
                                                    </p>
                                                </td>
                                                <td width="24"></td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                                <tr style="background-color: #FFF">
                                    <td>
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td height="17">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td align="center">
                                        Tem alguma dúvida? Quer nos dar sugestões? <b>Entre em contato conosco</b> contato@alibras.com.br
                                    </td>
                                </tr>
                                <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                    <td height="10">
                                        &nbsp;
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <table cellpadding="0" cellspacing="0">
                                            <tr style="color: #FFF; font: normal 14px Arial, Tahoma, sans-serif; text-align: left;">
                                                <td style="padding-right: 30px; padding-top: 30px; padding-left: 30px;">
                                                    <img src="$logo_bottom" />
                                                </td>
                                                <td valign="bottom">
                                                    Você está recebendo esse email por ter solicitado uma nova senha em nosso sistema. <br />
                                                    <br />
                                                </td>
                                            </tr>
                                        </table>
                                        <br /><br /><br /><br /><br />
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </body>
                    </html>
HTML;

        return $template;

    }

    /**
     * Envia email para operador informando a ele sua nova senha.
     * @param string $email Email do operador que tera sua senha enviada.
     * @return void
     * @author leonardocarvalho
     */
    public static function enviaEmailNovaSenha($email){

        try{

            // Valida se o email é existente
            self::validaEmailExistente($email);

            // Gera nova senha.
            $senha = self::getNewPassword();

            // Criptografa senha, e atualiza no banco.
            $novasenha = md5($senha);
            self::updateSenhaOper($email, $novasenha);

            $subject = self::SUBJECT_RECUPERAR_SENHA;
            $content = self::getTemplate($senha);

            // Manda um email para operador notificando a mudança de senha
            new Mail($email, $subject, $content);

        }
        catch(\Exception $e){
            throw new \Exception($e->getMessage(), $e->getCode());
        }

    }

    /**
     * Retorna uma senha aleatória de 10 dígitos
     * @return integer
     * @author leonardocarvalho
     */
    public static function getNewPassword() {
        $password =  rand(0,9).chr(rand(ord("a"), ord("z"))).
            rand(0,9).chr(rand(ord("A"), ord("Z"))).
            rand(0,9).chr(rand(ord("a"), ord("z")));

        return $password;
    }

    /**
     * @param $email
     * @param $senha
     * @author leonardocarvalho
     */
    public static function updateSenhaOper($email, $senha)
    {
        // Variavel de conexao com banco.
        $db = \TkModel::getConnection();

        // Query para update no banco de dados
        $update = " UPDATE OPERADOR
                    SET CDSENHAOPERWEB = '$senha'
                    WHERE DSEMAILOPER = '$email'";

        try {
            $db->exec($update);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage(), MCD_DBERROR_CODE);
        }
    }

    /**
     * Valida se o email é existente
     * @param $email
     * @author leonardocarvalho
     */
    public static function validaEmailExistente($email) {
        $emailExistente = \Curriculo\Logic\Cadastros\Operador::existeEmailCadastrado($email);
        if ($emailExistente == 0) {
            throw new \Exception('Email não existente.');
        }
    }

}